       IDENTIFICATION DIVISION.
      *********************************************************
      *********************************************************
       PROGRAM-ID.   FTPLOGON.
       ENVIRONMENT   DIVISION.
       CONFIGURATION SECTION.
       INPUT-OUTPUT  SECTION.
       FILE-CONTROL.
           SELECT FILEOUT    ASSIGN      TO DATABASE-FTPLOG
                  FILE STATUS            IS STA-FILEOUT.
      *********************************************************
       DATA DIVISION.
       FILE SECTION.

       FD  FILEOUT              LABEL RECORD IS STANDARD.
       01  RIGAOUT PIC X(55).

      *-------------------------------------------------------
       WORKING-STORAGE SECTION.

       77  STA-FILEOUT       PIC XX VALUE "ZZ".
       01  I   PIC S9(4).

       01 INT-USER PIC X(10).

       01 INT-PASSWD PIC X(10).

       01 USYSDATL.        COPY USYSDATL.
       01 LOG-RIGA.
           05 LOG-DATA     PIC X(10).
           05 LOG-ORA      PIC X(8).
           05 LOG-TCPIP    PIC X(15).
           05 LOG-USER     PIC X(10).
           05 LOG-GROUP    PIC X(10).
           05 LOG-STATE    PIC XX.

      *******************************
       LINKAGE SECTION.

       01 GRUPPO       PIC X(10).
       01 APP-IDENT    PIC 9(8) COMP-4.
       01 UTENTE       PIC X(999).
       01 UTENTE-LEN   PIC 9(8) COMP-4.
       01 PASSWD       PIC X(999).
       01 PASSWD-LEN   PIC 9(8) COMP-4.
       01 IPADDR       PIC X(15).
       01 IPADDR-LEN   PIC 9(8) COMP-4.
       01 RETRN-CODE   PIC 9(8) COMP-4.
       01 OUT-USER     PIC X(10).
       01 OUT-PASSWD   PIC X(10).
       01 OUT-LIBRARY  PIC X(10).

      ********************************************************
       PROCEDURE DIVISION USING GRUPPO
                                APP-IDENT UTENTE UTENTE-LEN PASSWD
                                PASSWD-LEN IPADDR IPADDR-LEN
                                RETRN-CODE OUT-USER OUT-PASSWD
                                OUT-LIBRARY.
       PROC-DIV.

           MOVE SPACES TO INT-USER
           MOVE SPACES TO INT-PASSWD

           OPEN EXTEND FILEOUT.
           IF STA-FILEOUT NOT = "00"
              DISPLAY "ERRORE FILE " STA-FILEOUT
           END-IF.

           CALL "USYSDATE" USING USYSDATL.
           MOVE SYS-DATE1  TO LOG-DATA
           MOVE SYS-TIME1  TO LOG-ORA

           MOVE  UTENTE (1 : UTENTE-LEN) TO INT-USER LOG-USER
           MOVE  PASSWD (1 : PASSWD-LEN) TO INT-PASSWD
           MOVE  IPADDR (1 : IPADDR-LEN) TO LOG-TCPIP
           MOVE  GRUPPO                  TO LOG-GROUP

      *--- BY DEFAULT, ALL OTHER USER ARE EXCLUDED
           MOVE 0     TO RETRN-CODE
           MOVE "NO"  TO LOG-STATE

      *--- put here your user or ip address selection
           IF GRUPPO   = "EDPOFFICE"
              MOVE "FTPDATA"   TO OUT-LIBRARY
              MOVE 2     TO RETRN-CODE
              MOVE "OK"  TO LOG-STATE
           END-IF.
      *---------------------------------------- 

           WRITE RIGAOUT FROM LOG-RIGA.
           CLOSE FILEOUT.

       FINE.
           Exit program.
      *-------------------------------------------------------
